/* ***********************************************************************/
/*                                                                       */
/*                      WiNRADiO G33DDC Excalibur Pro                    */
/*      Compat ioctl codes and definitions for G33DDC device driver      */
/*                     (C) Copyright 2015 RADIXON.                       */
/*                                                                       */
/* ***********************************************************************/

#ifndef __G33_IOCTL_COMPAT_H__
#define __G33_IOCTL_COMPAT_H__

#ifdef CONFIG_COMPAT

#pragma pack(push,1)

struct g33_usb_control1_compat
{
    uint16_t        params[3];
    compat_uptr_t   buffer;
    uint16_t        size;
    compat_uptr_t   transferred;
};

struct g33_usb_control2_compat
{
    compat_uptr_t   buffer;
    uint16_t        size;
    compat_uptr_t   transferred;
}; 

struct g33_fpga_data_compat
{
    compat_uptr_t   buffer;
    uint32_t        size;
};

struct g33_ddc1_start_params_compat
{
    uint32_t                buffer_size;
    uint32_t                bytes_per_sec;
    struct g33_ddc1_params  params;
    compat_uptr_t           coeffs;
};

#pragma pack(pop)

#define G33_IOCTL_CONFIGURE_FPGA_COMPAT             _IOW(0x8C,0x03,struct g33_fpga_data_compat)
#define G33_IOCTL_IF_PUT_BUFFER_COMPAT              _IOW(0x8C,0x09,compat_uptr_t)
#define G33_IOCTL_IF_GET_BUFFER_COMPAT              _IOR(0x8C,0x0A,compat_uptr_t)

#define G33_IOCTL_DDC1_0_START_COMPAT               _IOW(0x8C,0x0C,struct g33_ddc1_start_params_compat)
#define G33_IOCTL_DDC1_0_PUT_BUFFER_COMPAT          _IOW(0x8C,0x0F,compat_uptr_t)
#define G33_IOCTL_DDC1_0_GET_BUFFER_COMPAT          _IOR(0x8C,0x10,compat_uptr_t)

#define G33_IOCTL_USB_CONTROL1_READ_COMPAT          _IOR(0x8C,0x60,struct g33_usb_control1_compat)
#define G33_IOCTL_USB_CONTROL1_WRITE_COMPAT         _IOW(0x8C,0x61,struct g33_usb_control1_compat)
#define G33_IOCTL_USB_CONTROL2_READ_COMPAT          _IOR(0x8C,0x62,struct g33_usb_control2_compat)
#define G33_IOCTL_USB_CONTROL2_WRITE_COMPAT         _IOW(0x8C,0x63,struct g33_usb_control2_compat)

#endif //CONFIG_COMPAT

#endif // __G33_IOCTL_COMPAT_H__
